package edu.nyu.sps.face;

import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements SensorEventListener {
    //Can't initialize sensorManager and sensor until we get to onCreate.
    private SensorManager sensorManager;
    private Sensor sensor;

    private TextView textView;
    private String face_up;
    private String face_down;
    private String face_sideways;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView = (TextView)findViewById(R.id.textView);

        face_up       = getString(R.string.face_up);
        face_down     = getString(R.string.face_down);
        face_sideways = getString(R.string.face_sideways);

        sensorManager = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
        sensor = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (sensor != null) {
            sensorManager.registerListener(this, sensor, SensorManager.SENSOR_DELAY_NORMAL);
        }
    }

    @Override
    protected void onPause() {
        if (sensor != null) {
            sensorManager.unregisterListener(this);
        }
        super.onPause();
    }

    @Override
    public void onSensorChanged(SensorEvent sensorEvent) {
        //Use only one out of the three array elements for x, y, z.
        float z = sensorEvent.values[2];    //9.81 when lying face up.

        String s;
        if (z > 0) {
            s = face_up;
        } else if (z < 0) {
            s = face_down;
        } else {
            s = face_sideways;
        }
        textView.setText(s);
    }

    //Won't compile without this method.

    @Override
    public void onAccuracyChanged(Sensor sensor, int i) {
    }
}
